from abc import ABC, abstractmethod, abstractclassmethod
import typing
"""
This class implements the interface for a generic instrument class.
This base class is going to be used to inherit all the other instrument classes.
"""
class ams_instrument(ABC):
    """ams_instrument
    Generic isntrument base class interface.
    """
    def __init__(self, device_dict: dict) -> object:
        """__init__ 
        Initializes the ams_instrument object

        Args:
            device_dict (dict): dictionary of instrument settings

        Returns:
            object: ams_instrument object
        """
        pass


    @abstractmethod
    def IdentifyInstrument(self) -> str:
        """IdentifyInstrument 
        Gets the identifier of the instrument as string

        Returns:
            ID_string [String]: The identification string from the instrument
        """
        pass


    @abstractmethod
    def GetInstrumentError(self) -> str:
        """GetInstrumentError
        This function returns the error string from the instrument

        Returns:
            Error_string [String]: The error string from the instrument
        """
        pass 


    @abstractmethod
    def ResetInstrumehnt(self) -> None:
        """ResetInstrumehnt 
        This function resets the instrument
        """
        pass